12 research outputs found

    Finding Large Set Covers Faster via the Representation Method

    Get PDF
    The worst-case fastest known algorithm for the Set Cover problem on universes with n elements still essentially is the simple O^*(2^n)-time dynamic programming algorithm, and no non-trivial consequences of an O^*(1.01^n)-time algorithm are known. Motivated by this chasm, we study the following natural question: Which instances of Set Cover can we solve faster than the simple dynamic programming algorithm? Specifically, we give a Monte Carlo algorithm that determines the existence of a set cover of size sigma*n in O^*(2^{(1-Omega(sigma^4))n}) time. Our approach is also applicable to Set Cover instances with exponentially many sets: By reducing the task of finding the chromatic number chi(G) of a given n-vertex graph G to Set Cover in the natural way, we show there is an O^*(2^{(1-Omega(sigma^4))n})-time randomized algorithm that given integer s = sigma*n, outputs NO if chi(G) > s and YES with constant probability if chi(G) <= s - 1. On a high level, our results are inspired by the "representation method" of Howgrave-Graham and Joux~[EUROCRYPT\u2710] and obtained by only evaluating a randomly sampled subset of the table entries of a dynamic programming algorithm

    Fine-Grained Reductions and Quantum Speedups for Dynamic Programming

    Get PDF
    This paper points at a connection between certain (classical) fine-grained reductions and the question: Do quantum algorithms offer an advantage for problems whose (classical) best solution is via dynamic programming? A remarkable recent result of Ambainis et al. [SODA 2019] indicates that the answer is positive for some fundamental problems such as Set-Cover and Travelling Salesman. They design a quantum O^*(1.728^n) time algorithm whereas the dynamic programming O^*(2^n) time algorithms are conjectured to be classically optimal. In this paper, fine-grained reductions are extracted from their algorithms giving the first lower bounds for problems in P that are based on the intriguing Set-Cover Conjecture (SeCoCo) of Cygan et al. [CCC 2010]. In particular, the SeCoCo implies: - a super-linear Omega(n^{1.08}) lower bound for 3-SUM on n integers, - an Omega(n^{k/(c_k)-epsilon}) lower bound for k-SUM on n integers and k-Clique on n-node graphs, for any integer k >= 3, where c_k <= log_2{k}+1.4427. While far from being tight, these lower bounds are significantly stronger than what is known to follow from the Strong Exponential Time Hypothesis (SETH); the well-known n^{Omega(k)} ETH-based lower bounds for k-Clique and k-SUM are vacuous when k is constant. Going in the opposite direction, this paper observes that some "sequential" problems with previously known fine-grained reductions to a "parallelizable" core also enjoy quantum speedups over their classical dynamic programming solutions. Examples include RNA Folding and Least-Weight Subsequence

    The Set Cover Conjecture and Subgraph Isomorphism with a Tree Pattern

    Get PDF
    In the Set Cover problem, the input is a ground set of n elements and a collection of m sets, and the goal is to find the smallest sub-collection of sets whose union is the entire ground set. The fastest algorithm known runs in time O(mn2^n) [Fomin et al., WG 2004], and the Set Cover Conjecture (SeCoCo) [Cygan et al., TALG 2016] asserts that for every fixed epsilon>0, no algorithm can solve Set Cover in time 2^{(1-epsilon)n} poly(m), even if set sizes are bounded by Delta=Delta(epsilon). We show strong connections between this problem and kTree, a special case of Subgraph Isomorphism where the input is an n-node graph G and a k-node tree T, and the goal is to determine whether G has a subgraph isomorphic to T. First, we propose a weaker conjecture Log-SeCoCo, that allows input sets of size Delta=O(1/epsilon * log n), and show that an algorithm breaking Log-SeCoCo would imply a faster algorithm than the currently known 2^n poly(n)-time algorithm [Koutis and Williams, TALG 2016] for Directed nTree, which is kTree with k=n and arbitrary directions to the edges of G and T. This would also improve the running time for Directed Hamiltonicity, for which no algorithm significantly faster than 2^n poly(n) is known despite extensive research. Second, we prove that if p-Partial Cover, a parameterized version of Set Cover that requires covering at least p elements, cannot be solved significantly faster than 2^n poly(m) (an assumption even weaker than Log-SeCoCo) then kTree cannot be computed significantly faster than 2^k poly(n), the running time of the Koutis and Williams\u27 algorithm

    Breaking the All Subsets Barrier for Min k-Cut

    Get PDF

    The Asymptotic Rank Conjecture and the Set Cover Conjecture are not Both True

    Full text link
    Strassen's asymptotic rank conjecture [Progr. Math. 120 (1994)] claims a strong submultiplicative upper bound on the rank of a three-tensor obtained as an iterated Kronecker product of a constant-size base tensor. The conjecture, if true, most notably would put square matrix multiplication in quadratic time. We note here that some more-or-less unexpected algorithmic results in the area of exponential-time algorithms would also follow. Specifically, we study the so-called set cover conjecture, which states that for any ϵ>0\epsilon>0 there exists a positive integer constant kk such that no algorithm solves the kk-Set Cover problem in worst-case time O((2ϵ)nFpoly(n))\mathcal{O}((2-\epsilon)^n|\mathcal F|\operatorname{poly}(n)). The kk-Set Cover problem asks, given as input an nn-element universe UU, a family F\mathcal F of size-at-most-kk subsets of UU, and a positive integer tt, whether there is a subfamily of at most tt sets in F\mathcal F whose union is UU. The conjecture was formulated by Cygan et al. in the monograph Parameterized Algorithms [Springer, 2015] but was implicit as a hypothesis already in Cygan et al. [CCC 2012, ACM Trans. Algorithms 2016], there conjectured to follow from the Strong Exponential Time Hypothesis. We prove that if the asymptotic rank conjecture is true, then the set cover conjecture is false. Using a reduction by Krauthgamer and Trabelsi [STACS 2019], in this scenario we would also get a O((2δ)n)\mathcal{O}((2-\delta)^n)-time randomized algorithm for some constant δ>0\delta>0 for another well-studied problem for which no such algorithm is known, namely that of deciding whether a given nn-vertex directed graph has a Hamiltonian cycle

    Finding large set covers faster via the representation method

    No full text
    The worst-case fastest known algorithm for the Set Cover problem on universes with n elements still essentially is the simple O^*(2^n)-time dynamic programming algorithm, and no non-trivial consequences of an O^*(1.01^n)-time algorithm are known. Motivated by this chasm, we study the following natural question: Which instances of Set Cover can we solve faster than the simple dynamic programming algorithm? Specifically, we give a Monte Carlo algorithm that determines the existence of a set cover of size sigma*n in O^*(2^{(1-Omega(sigma^4))n}) time. Our approach is also applicable to Set Cover instances with exponentially many sets: By reducing the task of finding the chromatic number chi(G) of a given n-vertex graph G to Set Cover in the natural way, we show there is an O^*(2^{(1-Omega(sigma^4))n})-time randomized algorithm that given integer s = sigma*n, outputs NO if chi(G) > s and YES with constant probability if \chi(G) <= s - 1. On a high level, our results are inspired by the "representation method" of Howgrave-Graham and Joux~[EUROCRYPT'10] and obtained by only evaluating a randomly sampled subset of the table entries of a dynamic programming algorithm

    Improving Schroeppel and Shamir's Algorithm for Subset Sum via Orthogonal Vectors

    Get PDF
    We present an O(20.5n)\mathcal{O}^\star(2^{0.5n}) time and O(20.249999n)\mathcal{O}^\star(2^{0.249999n}) space randomized algorithm for solving worst-case Subset Sum instances with nn integers. This is the first improvement over the long-standing O(2n/2)\mathcal{O}^\star(2^{n/2}) time and O(2n/4)\mathcal{O}^\star(2^{n/4}) space algorithm due to Schroeppel and Shamir (FOCS 1979). We breach this gap in two steps: (1) We present a space efficient reduction to the Orthogonal Vectors Problem (OV), one of the most central problem in Fine-Grained Complexity. The reduction is established via an intricate combination of the method of Schroeppel and Shamir, and the representation technique introduced by Howgrave-Graham and Joux (EUROCRYPT 2010) for designing Subset Sum algorithms for the average case regime. (2) We provide an algorithm for OV that detects an orthogonal pair among NN given vectors in {0,1}d\{0,1\}^d with support size d/4d/4 in time O~(N2d/(dd/4))\tilde{O}(N\cdot2^d/\binom{d}{d/4}). Our algorithm for OV is based on and refines the representative families framework developed by Fomin, Lokshtanov, Panolan and Saurabh (J. ACM 2016). Our reduction uncovers a curious tight relation between Subset Sum and OV, because any improvement of our algorithm for OV would imply an improvement over the runtime of Schroeppel and Shamir, which is also a long standing open problem.Comment: STOC 2021, 38 pages, 3 figure

    Finding Large Set Covers Faster via the Representation Method

    No full text
    The worst-case fastest known algorithm for the Set Cover problem on universes with nn elements still essentially is the simple O(2n)O^*(2^n)-time dynamic programming algorithm, and no non-trivial consequences of an O(1.01n)O^*(1.01^n)-time algorithm are known. Motivated by this chasm, we study the following natural question: Which instances of Set Cover can we solve faster than the simple dynamic programming algorithm? Specifically, we give a Monte Carlo algorithm that determines the existence of a set cover of size σn\sigma n in O(2(1Ω(σ4))n)O^*(2^{(1-\Omega(\sigma^4))n}) time. Our approach is also applicable to Set Cover instances with exponentially many sets: By reducing the task of finding the chromatic number χ(G)\chi(G) of a given nn-vertex graph GG to Set Cover in the natural way, we show there is an O(2(1Ω(σ4))n)O^*(2^{(1-\Omega(\sigma^4))n})-time randomized algorithm that given integer s=σns=\sigma n, outputs NO if χ(G)>s\chi(G) > s and YES with constant probability if χ(G)s1\chi(G)\leq s-1. On a high level, our results are inspired by the `representation method' of Howgrave-Graham and Joux~[EUROCRYPT'10] and obtained by only evaluating a randomly sampled subset of the table entries of a dynamic programming algorithm
    corecore